<?php

function xml2array($s) {
  if ($Atmp1=explode('>',$s,2) and ereg('^<\?(xml .*)\?$',$Atmp1[0],$Atmp2)) {
    $A['xml']=$Atmp2[1];
    xml2array_sub($A,$Atmp1[1]);
  }
  return $A;
}

function xml2array_sub(&$A,$s) {
  global $error_msg;

  for ($c=0;ereg('<([^<>/ ]*)( [^<>]*)?/>(.*)',$s,$Atmp1) or
            ereg('<([^<>/ ]*)( [^<>]*)?>(.*)',$s,$Atmp1) and
            $Atmp2=explode('</'.$Atmp1[1].'>',$Atmp1[3],2);++$c) {
    $E=array();
    $tag=$Atmp1[1];
    if ($Atmp1[2]) {
      $Atmp3=explode(' ',substr($Atmp1[2],1));
      foreach ($Atmp3 as $d) {
        $Atmp4=explode('=',$d,2);
        $Atmp4[1]=ereg_replace('^"(.*)"$','\1',$Atmp4[1]);
        $E[$Atmp4[0]]=$Atmp4[1];
      }
    }
    if ($Atmp2) {
      if (!xml2array_sub($E,$Atmp2[0])) {
        $E=$Atmp2[0];
      }
      $s=$Atmp2[1];               //rest of the xml-code
      $Atmp2=false;
    }
    else {
      $s=$Atmp1[3];               //rest of the xml-code
    }
    if (isset($A[$tag])) {                        //does it already exist? 20040715: isset() added
      if (!is_array($A[$tag]) or !$A[$tag][0]) {  //not already a numberically indexed array?
        $Atag=$A[$tag];                           //remove element again
        unset($A[$tag]);
        $A[$tag][]=$Atag;                         //make old element first element of it's former self
      }
      if ($E) {
        $A[$tag][]=$E;            //add new element
      }
    }
    else {
      if ($E) {
        $A[$tag]=$E;                           //put it in the array under it's tag name
        if ($tag=='ErrorMsg') $error_msg=$E;  //make this a global error message, because it can be anywhere in the XML code
      }
    }
  }
  return $c;
}


function aws_signed_request($region, $params, $public_key, $private_key) {

    $method = "GET";
    $host = "ecs.amazonaws.".$region;
    $uri = "/onca/xml";
        $params["Service"] = "AWSECommerceService";
    $params["AWSAccessKeyId"] = $public_key;
    $params["Timestamp"] = gmdate("Y-m-d\TH:i:s\Z");
    $params["Version"] = "2011-08-01";

    ksort($params);
    
    $canonicalized_query = array();
    foreach ($params as $param=>$value)
    {
        $param = str_replace("%7E", "~", rawurlencode($param));
        $value = str_replace("%7E", "~", rawurlencode($value));
        $canonicalized_query[] = $param."=".$value;
    }
    $canonicalized_query = implode("&", $canonicalized_query);
    
  
    $string_to_sign = $method."\n".$host."\n".$uri."\n".$canonicalized_query;
    
    $signature = base64_encode(hash_hmac("sha256", $string_to_sign, $private_key, True));
       
    $signature = str_replace("%7E", "~", rawurlencode($signature));
    
   
    $request = "http://".$host.$uri."?".$canonicalized_query."&Signature=".$signature;

    return $request;

}

$parameters=array(
  'Operation'       =>'ItemSearch',
  'Keywords'        =>urlencode($_GET[search]),
  'SearchIndex'     =>'All',
  'ItemPage'        =>1,
  'ResponseGroup'   =>'ItemAttributes,Images,Medium',
  'AssociateTag'    => $amazon_tag
);

if(is_array($parameters)) {

$file_data='com';
ksort($parameters);
foreach ($parameters as $i=>$d) {
  $file_data.='&'.$i.'='.$d;
}

$file=aws_signed_request('com',$parameters,$amazon_public,$amazon_private);
$sfile=file_get_contents($file);

$output=xml2array(utf8_decode($sfile));
$items=$output['ItemSearchResponse']['Items']['Item'];

}
if(is_array($items)) {
	foreach($items as $item) {
		$temp = new stdClass;
		$temp->product->asin = $item['ASIN'];
		$temp->product->author->name = "Amazon";
		$temp->product->title = $item['ItemAttributes']['Title'];
		$temp->product->inventories[0]->price = str_replace('$', '', $item['ItemAttributes']['ListPrice']['FormattedPrice']);
		if($item['OfferSummary']['LowestNewPrice']['FormattedPrice'] != '') {
			$temp->product->inventories[0]->price = str_replace('$', '', $item['OfferSummary']['LowestNewPrice']['FormattedPrice']);
		}
		$temp->product->link = $item['DetailPageURL'];
		$temp->product->inventories[0]->image = $item['MediumImage']['URL'];
		$temp->product->inventories[0]->channel = 'online';
 		$temp->product->description = $item['EditorialReviews']['EditorialReview']['Content'];
		$results2[items][] = $temp;
	}
}

$results2 = json_decode(json_encode($results2));

?>